   This file documents the GNU Scientific Library.

   Copyright (C) 1996, 1997, 1998, 1999 The GSL Project.

   Permission is granted to make and distribute verbatim copies of this
manual provided the copyright notice and this permission notice are
preserved on all copies.

   Permission is granted to copy and distribute modified versions of
this manual under the conditions for verbatim copying, provided that
the entire resulting derived work is distributed under the terms of a
permission notice identical to this one.

   Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be stated in a
translation approved by the Foundation.

Raw BLAS Interface
==================

   The low-level `gsl_blas_raw' interface is specified in the file
`gsl_blas_raw.h'.

   Level 1

 - Function: float gsl_blas_raw_sdsdot (size_t N, float ALPHA, const
          float X[], size_t INCX, const float Y[], size_t INCY)

 - Function: double gsl_blas_raw_dsdot (size_t N, const float X[],
          size_t INCX, const float Y[], size_t INCY)

 - Function: float gsl_blas_raw_sdot (size_t N, const float X[], size_t
          INCX, const float Y[], size_t INCY)

 - Function: double gsl_blas_raw_ddot (size_t N, const double X[],
          size_t INCX, const double Y[], size_t INCY)

 - Function: void gsl_blas_raw_cdotu (size_t N, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_array_float Y, size_t INCY,
          gsl_complex_packed_float DOTU)

 - Function: void gsl_blas_raw_cdotc (size_t N, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_array_float Y, size_t INCY,
          gsl_complex_packed_float DOTC)

 - Function: void gsl_blas_raw_zdotu (size_t N, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed_array Y, size_t INCY,
          gsl_complex_packed DOTU)

 - Function: void gsl_blas_raw_zdotc (size_t N, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed_array Y, size_t INCY,
          gsl_complex_packed DOTC)

 - Function: float gsl_blas_raw_snrm2 (size_t N, const float X[],
          size_t INCX)

 - Function: double gsl_blas_raw_dnrm2 (size_t N, const double X[],
          size_t INCX)

 - Function: float gsl_blas_raw_scnrm2 (size_t N, const
          gsl_const_complex_packed_array_float X, size_t INCX)

 - Function: double gsl_blas_raw_dznrm2 (size_t N, const
          gsl_const_complex_packed_array X, size_t INCX)

 - Function: float gsl_blas_raw_sasum (size_t N, const float X[],
          size_t INCX)

 - Function: double gsl_blas_raw_dasum (size_t N, const double X[],
          size_t INCX)

 - Function: float gsl_blas_raw_scasum (size_t N, const
          gsl_const_complex_packed_array_float X, size_t INCX)

 - Function: double gsl_blas_raw_dzasum (size_t N, const
          gsl_const_complex_packed_array X, size_t INCX)

 - Function: CBLAS_INDEX_t gsl_blas_raw_isamax (size_t N, const float
          X[], size_t INCX)

 - Function: CBLAS_INDEX_t gsl_blas_raw_idamax (size_t N, const double
          X[], size_t INCX)

 - Function: CBLAS_INDEX_t gsl_blas_raw_icamax (size_t N, const
          gsl_const_complex_packed_array_float X, size_t INCX)

 - Function: CBLAS_INDEX_t gsl_blas_raw_izamax (size_t N, const
          gsl_const_complex_packed_array X, size_t INCX)

 - Function: void gsl_blas_raw_sswap (size_t N, float X[], size_t INCX,
          float Y[], size_t INCY)

 - Function: void gsl_blas_raw_dswap (size_t N, double X[], size_t
          INCX, double Y[], size_t INCY)

 - Function: void gsl_blas_raw_cswap (size_t N,
          gsl_complex_packed_array_float X, size_t INCX,
          gsl_complex_packed_array_float Y, size_t INCY)

 - Function: void gsl_blas_raw_zswap (size_t N,
          gsl_complex_packed_array X, size_t INCX,
          gsl_complex_packed_array Y, size_t INCY)

 - Function: void gsl_blas_raw_scopy (size_t N, const float X[], size_t
          INCX, float Y[], size_t INCY)

 - Function: void gsl_blas_raw_dcopy (size_t N, const double X[],
          size_t INCX, double Y[], size_t INCY)

 - Function: void gsl_blas_raw_ccopy (size_t N, const
          gsl_const_complex_packed_array_float X, size_t INCX,
          gsl_complex_packed_array_float Y, size_t INCY)

 - Function: void gsl_blas_raw_zcopy (size_t N, const
          gsl_const_complex_packed_array X, size_t INCX,
          gsl_complex_packed_array Y, size_t INCY)

 - Function: void gsl_blas_raw_saxpy (size_t N, float ALPHA, const
          float X[], size_t INCX, float Y[], size_t INCY)

 - Function: void gsl_blas_raw_daxpy (size_t N, double ALPHA, const
          double X[], size_t INCX, double Y[], size_t INCY)

 - Function: void gsl_blas_raw_caxpy (size_t N, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float X, size_t INCX,
          gsl_complex_packed_array_float Y, size_t INCY)

 - Function: void gsl_blas_raw_zaxpy (size_t N, const
          gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array X, size_t INCX,
          gsl_complex_packed_array Y, size_t INCY)

 - Function: void gsl_blas_raw_srotg (float a[], float b[], float c[],
          float s[])

 - Function: void gsl_blas_raw_drotg (double a[], double b[], double
          c[], double s[])

 - Function: void gsl_blas_raw_srotmg (float d1[], float d2[], float
          b1[], float B2, float P[])

 - Function: void gsl_blas_raw_drotmg (double d1[], double d2[], double
          b1[], double B2, double P[])

 - Function: void gsl_blas_raw_srot (size_t N, float X[], size_t INCX,
          float Y[], size_t INCY, const float C, const float S)

 - Function: void gsl_blas_raw_drot (size_t N, double X[], size_t INCX,
          double Y[], size_t INCY, const double C, const double S)

 - Function: void gsl_blas_raw_srotm (size_t N, float X[], size_t INCX,
          float Y[], size_t INCY, const float P[])

 - Function: void gsl_blas_raw_drotm (size_t N, double X[], size_t
          INCX, double Y[], size_t INCY, const double P[])

 - Function: void gsl_blas_raw_sscal (size_t N, float ALPHA, float X[],
          size_t INCX)

 - Function: void gsl_blas_raw_dscal (size_t N, double ALPHA, double
          X[], size_t INCX)

 - Function: void gsl_blas_raw_cscal (size_t N, const
          gsl_const_complex_packed_float ALPHA,
          gsl_complex_packed_array_float X, size_t INCX)

 - Function: void gsl_blas_raw_zscal (size_t N, const
          gsl_const_complex_packed ALPHA, gsl_complex_packed_array X,
          size_t INCX)

 - Function: void gsl_blas_raw_csscal (size_t N, float ALPHA,
          gsl_complex_packed_array_float X, size_t INCX)

 - Function: void gsl_blas_raw_zdscal (size_t N, double ALPHA,
          gsl_complex_packed_array X, size_t INCX)

   Level 2

 - Function: void gsl_blas_raw_sgemv (CBLAS_TRANSPOSE_t TRANSA, size_t
          M, size_t N, float ALPHA, const float A[], int LDA, const
          float X[], size_t INCX, float BETA, float Y[], size_t INCY)

 - Function: void gsl_blas_raw_dgemv (CBLAS_TRANSPOSE_t TRANSA, size_t
          M, size_t N, double ALPHA, const double A[], int LDA, const
          double X[], size_t INCX, double BETA, double Y[], size_t INCY)

 - Function: void gsl_blas_raw_cgemv (CBLAS_TRANSPOSE_t TRANSA, size_t
          M, size_t N, const gsl_const_complex_packed_float ALPHA,
          const gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float Y, size_t INCY)

 - Function: void gsl_blas_raw_zgemv (CBLAS_TRANSPOSE_t TRANSA, size_t
          M, size_t N, const gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array Y,
          size_t INCY)

 - Function: void gsl_blas_raw_sgbmv (CBLAS_TRANSPOSE_t TRANSA, size_t
          M, size_t N, size_t KL, size_t KU, float ALPHA, const float
          A[], int LDA, const float X[], size_t INCX, float BETA, float
          Y[], size_t INCY)

 - Function: void gsl_blas_raw_dgbmv (CBLAS_TRANSPOSE_t TRANSA, size_t
          M, size_t N, size_t KL, size_t KU, double ALPHA, const double
          A[], int LDA, const double X[], size_t INCX, double BETA,
          double Y[], size_t INCY)

 - Function: void gsl_blas_raw_cgbmv (CBLAS_TRANSPOSE_t TRANSA, size_t
          M, size_t N, size_t KL, size_t KU, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float Y, size_t INCY)

 - Function: void gsl_blas_raw_zgbmv (CBLAS_TRANSPOSE_t TRANSA, size_t
          M, size_t N, size_t KL, size_t KU, const
          gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array Y,
          size_t INCY)

 - Function: void gsl_blas_raw_strmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          float A[], int LDA, float X[], size_t INCX)

 - Function: void gsl_blas_raw_dtrmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          double A[], int LDA, double X[], size_t INCX)

 - Function: void gsl_blas_raw_ctrmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          gsl_const_complex_packed_array_float A, int LDA,
          gsl_complex_packed_array_float X, size_t INCX)

 - Function: void gsl_blas_raw_ztrmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          gsl_const_complex_packed_array A, int LDA,
          gsl_complex_packed_array X, size_t INCX)

 - Function: void gsl_blas_raw_stbmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, size_t
          K, const float A[], int LDA, float X[], size_t INCX)

 - Function: void gsl_blas_raw_dtbmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, size_t
          K, const double A[], int LDA, double X[], size_t INCX)

 - Function: void gsl_blas_raw_ctbmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, size_t
          K, const gsl_const_complex_packed_array_float A, int LDA,
          gsl_complex_packed_array_float X, size_t INCX)

 - Function: void gsl_blas_raw_ztbmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, size_t
          K, const gsl_const_complex_packed_array A, int LDA,
          gsl_complex_packed_array X, size_t INCX)

 - Function: void gsl_blas_raw_stpmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          float Ap[], float X[], size_t INCX)

 - Function: void gsl_blas_raw_dtpmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          double Ap[], double X[], size_t INCX)

 - Function: void gsl_blas_raw_ctpmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          gsl_const_complex_packed_array_float AP,
          gsl_complex_packed_array_float X, size_t INCX)

 - Function: void gsl_blas_raw_ztpmv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          gsl_const_complex_packed_array AP, gsl_complex_packed_array
          X, size_t INCX)

 - Function: void gsl_blas_raw_strsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          float A[], int LDA, float X[], size_t INCX)

 - Function: void gsl_blas_raw_dtrsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          double A[], int LDA, double X[], size_t INCX)

 - Function: void gsl_blas_raw_ctrsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          gsl_const_complex_packed_array_float A, int LDA,
          gsl_complex_packed_array_float X, size_t INCX)

 - Function: void gsl_blas_raw_ztrsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          gsl_const_complex_packed_array A, int LDA,
          gsl_complex_packed_array X, size_t INCX)

 - Function: void gsl_blas_raw_stbsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, size_t
          K, const float A[], int LDA, float X[], size_t INCX)

 - Function: void gsl_blas_raw_dtbsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, size_t
          K, const double A[], int LDA, double X[], size_t INCX)

 - Function: void gsl_blas_raw_ctbsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, size_t
          K, const gsl_const_complex_packed_array_float A, int LDA,
          gsl_complex_packed_array_float X, size_t INCX)

 - Function: void gsl_blas_raw_ztbsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, size_t
          K, const gsl_const_complex_packed_array A, int LDA,
          gsl_complex_packed_array X, size_t INCX)

 - Function: void gsl_blas_raw_stpsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          float Ap[], float X[], size_t INCX)

 - Function: void gsl_blas_raw_dtpsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          double Ap[], double X[], size_t INCX)

 - Function: void gsl_blas_raw_ctpsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          gsl_const_complex_packed_array_float AP,
          gsl_complex_packed_array_float X, size_t INCX)

 - Function: void gsl_blas_raw_ztpsv (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t N, const
          gsl_const_complex_packed_array AP, gsl_complex_packed_array
          X, size_t INCX)

 - Function: void gsl_blas_raw_ssymv (CBLAS_UPLO_t UPLO, size_t N,
          float ALPHA, const float A[], int LDA, const float X[],
          size_t INCX, float BETA, float Y[], size_t INCY)

 - Function: void gsl_blas_raw_dsymv (CBLAS_UPLO_t UPLO, size_t N,
          double ALPHA, const double A[], int LDA, const double X[],
          size_t INCX, double BETA, double Y[], size_t INCY)

 - Function: void gsl_blas_raw_ssbmv (CBLAS_UPLO_t UPLO, size_t N,
          size_t K, float ALPHA, const float A[], int LDA, const float
          X[], size_t INCX, float BETA, float Y[], size_t INCY)

 - Function: void gsl_blas_raw_dsbmv (CBLAS_UPLO_t UPLO, size_t N,
          size_t K, double ALPHA, const double A[], int LDA, const
          double X[], size_t INCX, double BETA, double Y[], size_t INCY)

 - Function: void gsl_blas_raw_sspmv (CBLAS_UPLO_t UPLO, size_t N,
          float ALPHA, const float Ap[], const float X[], size_t INCX,
          float BETA, float Y[], size_t INCY)

 - Function: void gsl_blas_raw_dspmv (CBLAS_UPLO_t UPLO, size_t N,
          double ALPHA, const double Ap[], const double X[], size_t
          INCX, double BETA, double Y[], size_t INCY)

 - Function: void gsl_blas_raw_sger (size_t M, size_t N, float ALPHA,
          const float X[], size_t INCX, const float Y[], size_t INCY,
          float A[], int LDA)

 - Function: void gsl_blas_raw_dger (size_t M, size_t N, double ALPHA,
          const double X[], size_t INCX, const double Y[], size_t INCY,
          double A[], int LDA)

 - Function: void gsl_blas_raw_ssyr (CBLAS_UPLO_t UPLO, size_t N, float
          ALPHA, const float X[], size_t INCX, float A[], int LDA)

 - Function: void gsl_blas_raw_dsyr (CBLAS_UPLO_t UPLO, size_t N,
          double ALPHA, const double X[], size_t INCX, double A[], int
          LDA)

 - Function: void gsl_blas_raw_sspr (CBLAS_UPLO_t UPLO, size_t N, float
          ALPHA, const float X[], size_t INCX, float Ap[])

 - Function: void gsl_blas_raw_dspr (CBLAS_UPLO_t UPLO, size_t N,
          double ALPHA, const double X[], size_t INCX, double Ap[])

 - Function: void gsl_blas_raw_ssyr2 (CBLAS_UPLO_t UPLO, size_t N,
          float ALPHA, const float X[], size_t INCX, const float Y[],
          size_t INCY, float A[], int LDA)

 - Function: void gsl_blas_raw_dsyr2 (CBLAS_UPLO_t UPLO, size_t N,
          double ALPHA, const double X[], size_t INCX, const double
          Y[], size_t INCY, double A[], int LDA)

 - Function: void gsl_blas_raw_sspr2 (CBLAS_UPLO_t UPLO, size_t N,
          float ALPHA, const float X[], size_t INCX, const float Y[],
          size_t INCY, float A[])

 - Function: void gsl_blas_raw_dspr2 (CBLAS_UPLO_t UPLO, size_t N,
          double ALPHA, const double X[], size_t INCX, const double
          Y[], size_t INCY, double A[])

 - Function: void gsl_blas_raw_chemv (CBLAS_UPLO_t UPLO, size_t N,
          const gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float Y, size_t INCY)

 - Function: void gsl_blas_raw_zhemv (CBLAS_UPLO_t UPLO, size_t N,
          const gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array Y,
          size_t INCY)

 - Function: void gsl_blas_raw_chbmv (CBLAS_UPLO_t UPLO, size_t N,
          size_t K, const gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float Y, size_t INCY)

 - Function: void gsl_blas_raw_zhbmv (CBLAS_UPLO_t UPLO, size_t N,
          size_t K, const gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array Y,
          size_t INCY)

 - Function: void gsl_blas_raw_chpmv (CBLAS_UPLO_t UPLO, size_t N,
          const gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float AP, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float Y, size_t INCY)

 - Function: void gsl_blas_raw_zhpmv (CBLAS_UPLO_t UPLO, size_t N,
          const gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array AP, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array Y,
          size_t INCY)

 - Function: void gsl_blas_raw_cgeru (size_t M, size_t N, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_array_float Y, size_t INCY,
          gsl_complex_packed_array_float A, int LDA)

 - Function: void gsl_blas_raw_zgeru (size_t M, size_t N, const
          gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed_array Y, size_t INCY,
          gsl_complex_packed_array A, int LDA)

 - Function: void gsl_blas_raw_cgerc (size_t M, size_t N, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_array_float Y, size_t INCY,
          gsl_complex_packed_array_float A, int LDA)

 - Function: void gsl_blas_raw_zgerc (size_t M, size_t N, const
          gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed_array Y, size_t INCY,
          gsl_complex_packed_array A, int LDA)

 - Function: void gsl_blas_raw_cher (CBLAS_UPLO_t UPLO, size_t N, float
          ALPHA, const gsl_const_complex_packed_array_float X, size_t
          INCX, gsl_complex_packed_array_float A, int LDA)

 - Function: void gsl_blas_raw_zher (CBLAS_UPLO_t UPLO, size_t N,
          double ALPHA, const gsl_const_complex_packed_array X, size_t
          INCX, gsl_complex_packed_array A, int LDA)

 - Function: void gsl_blas_raw_chpr (CBLAS_UPLO_t UPLO, size_t N, float
          ALPHA, const gsl_const_complex_packed_array_float X, size_t
          INCX, gsl_complex_packed_array_float A)

 - Function: void gsl_blas_raw_zhpr (CBLAS_UPLO_t UPLO, size_t N,
          double ALPHA, const gsl_const_complex_packed_array X, size_t
          INCX, gsl_complex_packed_array A)

 - Function: void gsl_blas_raw_cher2 (CBLAS_UPLO_t UPLO, size_t N,
          const gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_array_float Y, size_t INCY,
          gsl_complex_packed_array_float A, int LDA)

 - Function: void gsl_blas_raw_zher2 (CBLAS_UPLO_t UPLO, size_t N,
          const gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed_array Y, size_t INCY,
          gsl_complex_packed_array A, int LDA)

 - Function: void gsl_blas_raw_chpr2 (CBLAS_UPLO_t UPLO, size_t N,
          const gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float X, size_t INCX, const
          gsl_const_complex_packed_array_float Y, size_t INCY,
          gsl_complex_packed_array_float AP)

 - Function: void gsl_blas_raw_zhpr2 (CBLAS_UPLO_t UPLO, size_t N,
          const gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array X, size_t INCX, const
          gsl_const_complex_packed_array Y, size_t INCY,
          gsl_complex_packed_array AP)

   Level 3

 - Function: void gsl_blas_raw_sgemm (CBLAS_TRANSPOSE_t TRANSA,
          CBLAS_TRANSPOSE_t TRANSB, size_t M, size_t N, size_t K, float
          ALPHA, const float A[], int LDA, const float B[], int LDB,
          float BETA, float C[], int LDC)

 - Function: void gsl_blas_raw_dgemm (CBLAS_TRANSPOSE_t TRANSA,
          CBLAS_TRANSPOSE_t TRANSB, size_t M, size_t N, size_t K,
          double ALPHA, const double A[], int LDA, const double B[],
          int LDB, double BETA, double C[], int LDC)

 - Function: void gsl_blas_raw_cgemm (CBLAS_TRANSPOSE_t TRANSA,
          CBLAS_TRANSPOSE_t TRANSB, size_t M, size_t N, size_t K, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float B, int LDB, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float C, int LDC)

 - Function: void gsl_blas_raw_zgemm (CBLAS_TRANSPOSE_t TRANSA,
          CBLAS_TRANSPOSE_t TRANSB, size_t M, size_t N, size_t K, const
          gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array B, int LDB, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array C,
          int LDC)

 - Function: void gsl_blas_raw_ssymm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, size_t M, size_t N, float ALPHA, const float A[], int
          LDA, const float B[], int LDB, float BETA, float C[], int LDC)

 - Function: void gsl_blas_raw_dsymm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, size_t M, size_t N, double ALPHA, const double A[], int
          LDA, const double B[], int LDB, double BETA, double C[], int
          LDC)

 - Function: void gsl_blas_raw_csymm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, size_t M, size_t N, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float B, int LDB, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float C, int LDC)

 - Function: void gsl_blas_raw_zsymm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, size_t M, size_t N, const gsl_const_complex_packed
          ALPHA, const gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array B, int LDB, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array C,
          int LDC)

 - Function: void gsl_blas_raw_ssyrk (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, float ALPHA,
          const float A[], int LDA, float BETA, float C[], int LDC)

 - Function: void gsl_blas_raw_dsyrk (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, double ALPHA,
          const double A[], int LDA, double BETA, double C[], int LDC)

 - Function: void gsl_blas_raw_csyrk (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float C, int LDC)

 - Function: void gsl_blas_raw_zsyrk (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, const
          gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array C,
          int LDC)

 - Function: void gsl_blas_raw_ssyr2k (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, float ALPHA,
          const float A[], int LDA, const float B[], int LDB, float
          BETA, float C[], int LDC)

 - Function: void gsl_blas_raw_dsyr2k (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, double ALPHA,
          const double A[], int LDA, const double B[], int LDB, double
          BETA, double C[], int LDC)

 - Function: void gsl_blas_raw_csyr2k (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float B, int LDB, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float C, int LDC)

 - Function: void gsl_blas_raw_zsyr2k (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, const
          gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array B, int LDB, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array C,
          int LDC)

 - Function: void gsl_blas_raw_strmm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t M,
          size_t N, float ALPHA, const float A[], int LDA, float B[],
          int LDB)

 - Function: void gsl_blas_raw_dtrmm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t M,
          size_t N, double ALPHA, const double A[], int LDA, double
          B[], int LDB)

 - Function: void gsl_blas_raw_ctrmm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t M,
          size_t N, const gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA,
          gsl_complex_packed_array_float B, int LDB)

 - Function: void gsl_blas_raw_ztrmm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t M,
          size_t N, const gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA,
          gsl_complex_packed_array B, int LDB)

 - Function: void gsl_blas_raw_strsm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t M,
          size_t N, float ALPHA, const float A[], int LDA, float B[],
          int LDB)

 - Function: void gsl_blas_raw_dtrsm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t M,
          size_t N, double ALPHA, const double A[], int LDA, double
          B[], int LDB)

 - Function: void gsl_blas_raw_ctrsm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t M,
          size_t N, const gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA,
          gsl_complex_packed_array_float B, int LDB)

 - Function: void gsl_blas_raw_ztrsm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, CBLAS_TRANSPOSE_t TRANSA, CBLAS_DIAG_t DIAG, size_t M,
          size_t N, const gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA,
          gsl_complex_packed_array B, int LDB)

 - Function: void gsl_blas_raw_chemm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, size_t M, size_t N, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float B, int LDB, const
          gsl_const_complex_packed_float BETA,
          gsl_complex_packed_array_float C, int LDC)

 - Function: void gsl_blas_raw_zhemm (CBLAS_SIDE_t SIDE, CBLAS_UPLO_t
          UPLO, size_t M, size_t N, const gsl_const_complex_packed
          ALPHA, const gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array B, int LDB, const
          gsl_const_complex_packed BETA, gsl_complex_packed_array C,
          int LDC)

 - Function: void gsl_blas_raw_cherk (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, float ALPHA,
          const gsl_const_complex_packed_array_float A, int LDA, float
          BETA, gsl_complex_packed_array_float C, int LDC)

 - Function: void gsl_blas_raw_zherk (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, double ALPHA,
          const gsl_const_complex_packed_array A, int LDA, double BETA,
          gsl_complex_packed_array C, int LDC)

 - Function: void gsl_blas_raw_cher2k (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, const
          gsl_const_complex_packed_float ALPHA, const
          gsl_const_complex_packed_array_float A, int LDA, const
          gsl_const_complex_packed_array_float B, int LDB, float BETA,
          gsl_complex_packed_array_float C, int LDC)

 - Function: void gsl_blas_raw_zher2k (CBLAS_UPLO_t UPLO,
          CBLAS_TRANSPOSE_t TRANS, size_t N, size_t K, const
          gsl_const_complex_packed ALPHA, const
          gsl_const_complex_packed_array A, int LDA, const
          gsl_const_complex_packed_array B, int LDB, double BETA,
          gsl_complex_packed_array C, int LDC)

References and Further Reading
==============================

   Information on the BLAS standards, including both the legacy and
draft interface standards, is available online from the BLAS Technical
Forum web-site.

     `BLAS Technical Forum'
     <http://www.netlib.org/cgi-bin/checkout/blast/blast.pl>

The following papers contain the specifications for Level 1, Level 2 and
Level 3 BLAS.

     C. Lawson, R. Hanson, D. Kincaid, F. Krogh, "Basic Linear Algebra
     Subprograms for Fortran Usage", `ACM Transactions on Mathematical
     Software', Vol. 5 (1979), Pages 308-325.

     J.J. Dongarra, J. DuCroz, S. Hammarling, R. Hanson, "An Extended
     Set of Fortran Basic Linear Algebra Subprograms", `ACM
     Transactions on Mathematical Software', Vol. 14, No. 1 (1988),
     Pages 1-32.

     J.J. Dongarra, I. Duff, J. DuCroz, S. Hammarling, "A Set of Level
     3 Basic Linear Algebra Subprograms", `ACM Transactions on
     Mathematical Software', Vol. 16 (1990), Pages 1-28.

Linear Algebra
**************

   This chapter describes functions for solving linear systems.  The
library provides simple linear algebra operations which operate directly
on the `gsl_vector' and `gsl_matrix' objects.  These are meant for
"small" systems where simple algorithms are acceptable.

   Anyone interested in large systems will want to use the sophisticated
routines found in LAPACK. The Fortran version of LAPACK is recommended
as the standard package for linear algebra.  It supports blocked
algorithms, specialized data representations and other optimizations.

LU Decomposition
================

   A general square matrix A has an LU decomposition into upper and
lower triangular matrices,

     P A = L U

where P is a permutation matrix, L is unit lower triangular matrix and
R is upper triangular matrix. For square matrices this decomposition
can be used to convert the linear system A x = b into a pair of
triangular systems (L y = P b, U x = y), which can be solved by forward
and back-substitution.

 - Function: int gsl_linalg_LU_decomp (gsl_matrix * A, gsl_permutation
          * P, int *SIGNUM)
     This function factorizes the square matrix A into the LU
     decomposition PA = LU.  On output the diagonal and upper
     triangular part of the input matrix A contain the matrix R. The
     lower triangular part of the input matrix (excluding the diagonal)
     contains L.  The diagonal elements of L are unity, and are not
     stored.

     The permutation matrix P is encoded in the permutation P. The j-th
     column of the matrix P is given by the k-th column of the identity
     matrix, where k = p_j the j-th element of the permutation vector.
     The sign of the permutation is given by SIGNUM. It has the value
     (-1)^n, where n is the number of interchanges in the permutation.

     The algorithm used in the decomposition is Gaussian Elimination
     with partial pivoting (Golub & Van Loan, `Matrix Computations',
     Algorithm 3.4.1).

 - Function: int gsl_linalg_LU_solve (const gsl_matrix * LU, const
          gsl_permutation * P, const gsl_vector * B, gsl_vector * X)
     This function solves the system A x = b using the LU decomposition
     of A into (LU, P) given by `gsl_linalg_LU_decomp'.

 - Function: int gsl_linalg_LU_svx (const gsl_matrix * LU, const
          gsl_permutation * P, gsl_vector * X)
     This function solves the system A x = b in-place using the LU
     decomposition of A into (LU,P). On input X should contain the
     right-hand side b, which is replaced by the solution on output.

 - Function: int gsl_linalg_LU_refine (const gsl_matrix * A, const
          gsl_matrix * LU, const gsl_permutation * P, const gsl_vector
          * B, gsl_vector * X, gsl_vector * RESIDUAL)
     This function applies an iterative improvement to X, the solution
     of A x = b, using the LU decomposition of A into (LU,P). The
     initial residual r = A x - b is also computed and stored in
     RESIDUAL.

 - Function: int gsl_linalg_LU_invert (const gsl_matrix * LU, const
          gsl_permutation * P, gsl_matrix * INVERSE)
     This function computes the inverse of a matrix A from its LU
     decomposition (LU,P), storing the result in the matrix INVERSE.
     The inverse is computed by solving the system A x = b for each
     column of the identity matrix.

 - Function: double gsl_linalg_LU_det (gsl_matrix * LU, int SIGNUM)
     This function computes the determinant of a matrix A from its LU
     decomposition, LU. The determinant is computed as the product of
     the diagonal elements of U and the sign of the row permutation
     SIGNUM.

 - Function: double gsl_linalg_LU_lndet (gsl_matrix * LU)
     This function computes the logarithm of the absolute value of the
     determinant of a matrix A, \ln|det(A)|, from its LU decomposition,
     LU.  This function may be useful if the direct computation of the
     determinant would overflow or underflow.

 - Function: int gsl_linalg_LU_sgndet (gsl_matrix * LU, int SIGNUM)
     This function computes the sign of the determinant of a matrix A,
     sign(det(A)), from its LU decomposition, LU.

QR Decomposition
================

   A general rectangular M-by-N matrix A has a QR decomposition into
the product of an orthogonal M-by-M square matrix Q (where Q^T Q = I)
and an M-by-N right-triangular matrix R,

     A = Q R

This decomposition can be used to convert the linear system A x = b
into the triangular system R x = Q^T b, which can be solved by
back-substitution. Another use of the QR decomposition is to compute an
orthonormal basis for a set of vectors. The first N columns of Q form
an orthonormal basis for the range of A, ran(A), when A has full column
rank.

 - Function: int gsl_linalg_QR_decomp (gsl_matrix * A, gsl_vector * TAU)
     This function factorizes the M-by-N matrix A into the QR
     decomposition A = Q R.  On output the diagonal and upper
     triangular part of the input matrix contain the matrix R. The
     vector TAU and the columns of the lower triangular part of the
     matrix A contain the Householder coefficients and Householder
     vectors which encode the orthogonal matrix Q.  The vector TAU must
     be of length k=\min(M,N). The matrix Q is related to these
     components by, Q = Q_k ... Q_2 Q_1 where Q_i = I - \tau_i v_i
     v_i^T and v_i is the Householder vector v_i =
     (0,...,1,A(i+1,i),A(i+2,i),...,A(m,i)). This is the same storage
     scheme as used by LAPACK.

     The algorithm used to perform the decomposition is Householder QR
     (Golub & Van Loan, `Matrix Computations', Algorithm 5.2.1).

 - Function: int gsl_linalg_QR_solve (const gsl_matrix * QR, const
          gsl_vector * TAU, const gsl_vector * B, gsl_vector * X)
     This function solves the system A x = b using the QR decomposition
     of A into (QR, TAU) given by `gsl_linalg_QR_decomp'.

 - Function: int gsl_linalg_QR_svx (const gsl_matrix * QR, const
          gsl_vector * TAU, gsl_vector * X)
     This function solves the system A x = b in-place using the QR
     decomposition of A into (QR,TAU). On input X should contain the
     right-hand side b, which is replaced by the solution on output.

 - Function: int gsl_linalg_QR_QTvec (const gsl_matrix * QR, const
          gsl_vector * TAU, gsl_vector * V)
     This function applies the matrix Q^T encoded in the decomposition
     (QR,TAU) to the vector V, storing the result Q^T v in V.  The
     matrix multiplication is carried out directly using the encoding
     of the Householder vectors without needing to form the full matrix
     Q^T.

 - Function: int gsl_linalg_QR_Rsolve (const gsl_matrix * QR, const
          gsl_vector * B, gsl_vector * X)
     This function solves the triangular system R x = b for X. It may
     be useful if the product b' = Q^T b has already been computed
     using `gsl_linalg_QR_QTvec'.

 - Function: int gsl_linalg_QR_Rsvx (const gsl_matrix * QR, gsl_vector
          * X)
     This function solves the triangular system R x = b for X in-place.
     On input X should contain the right-hand side b and is replaced by
     the solution on output. This function may be useful if the product
     b' = Q^T b has already been computed using `gsl_linalg_QR_QTvec'.

 - Function: int gsl_linalg_QR_unpack (const gsl_matrix * QR, const
          gsl_vector * TAU, gsl_matrix * Q, gsl_matrix * R)
     This function unpacks the encoded QR decomposition (QR,TAU) into
     the matrices Q and R, where Q is M-by-M and R is M-by-N.

 - Function: int gsl_linalg_QR_QRsolve (gsl_matrix * Q, gsl_matrix * R,
          const gsl_vector * B, gsl_vector * X)
     This function solves the system R x = Q^T b for X. It can be used
     when the QR decomposition of a matrix is available in unpacked
     form as (Q,R).

 - Function: int gsl_linalg_QR_update (gsl_matrix * Q, gsl_matrix * R,
          gsl_vector * W, const gsl_vector * V)
     This function performs a rank-1 update w v^T of the QR
     decomposition (Q, R). The update is given by Q'R' = Q R + w v^T
     where the output matrices Q' and R' are also orthogonal and right
     triangular. Note that W is destroyed by the update.

 - Function: int gsl_linalg_R_solve (const gsl_matrix * R, const
          gsl_vector * B, gsl_vector * X)
     This function solves the triangular system R x = b for the N-by-N
     matrix R.

 - Function: int gsl_linalg_R_svx (const gsl_matrix * R, gsl_vector * X)
     This function solves the triangular system R x = b in-place. On
     input X should contain the right-hand side b, which is replaced by
     the solution on output.

QR Decomposition with Column Pivoting
=====================================

   The QR decomposition can be extended to the rank deficient case by
introducing a column permutation P,

     A P = Q R

The first r columns of this Q form an orthonormal basis for the range
of A for a matrix with column rank r.  This decomposition can also be
used to convert the linear system A x = b into the triangular system R
y = Q^T b, x = P y, which can be solved by back-substitution and
permutation.  We denote the QR decomposition with column pivoting by
QRP^T since A = Q R P^T.

 - Function: int gsl_linalg_QRPT_decomp (gsl_matrix * A, gsl_vector *
          TAU, gsl_permutation * P, int *SIGNUM)
     This function factorizes the M-by-N matrix A into the QRP^T
     decomposition A = Q R P^T.  On output the diagonal and upper
     triangular part of the input matrix contain the matrix R. The
     permutation matrix P is stored in the permutation P.  The sign of
     the permutation is given by SIGNUM. It has the value (-1)^n, where
     n is the number of interchanges in the permutation. The vector TAU
     and the columns of the lower triangular part of the matrix A
     contain the Householder coefficients and vectors which encode the
     orthogonal matrix Q.  The vector TAU must be of length
     k=\min(M,N). The matrix Q is related to these components by, Q =
     Q_k ... Q_2 Q_1 where Q_i = I - \tau_i v_i v_i^T and v_i is the
     Householder vector v_i = (0,...,1,A(i+1,i),A(i+2,i),...,A(m,i)).
     This is the same storage scheme as used by LAPACK.

     The algorithm used to perform the decomposition is Householder QR
     with column pivoting (Golub & Van Loan, `Matrix Computations',
     Algorithm 5.4.1).

 - Function: int gsl_linalg_QRPT_solve (const gsl_matrix * QR, const
          gsl_vector * TAU, const gsl_permutation * P, const gsl_vector
          * B, gsl_vector * X)
     This function solves the system A x = b using the QRP^T
     decomposition of A into (QR, TAU, P) given by
     `gsl_linalg_QRPT_decomp'.

 - Function: int gsl_linalg_QRPT_svx (const gsl_matrix * QR, const
          gsl_vector * TAU, const gsl_permutation * P, gsl_vector * X)
     This function solves the system A x = b in-place using the QRP^T
     decomposition of A into (QR,TAU,P). On input X should contain the
     right-hand side b, which is replaced by the solution on output.

 - Function: int gsl_linalg_QRPT_QRsolve (const gsl_matrix * Q, const
          gsl_matrix * R, const gsl_permutation * P, const gsl_vector *
          B, gsl_vector * X)
     This function solves the system R P^T x = Q^T b for X. It can be
     used when the QR decomposition of a matrix is available in
     unpacked form as (Q,R).

 - Function: int gsl_linalg_QRPT_update (gsl_matrix * Q, gsl_matrix *
          R, const gsl_permutation * P, gsl_vector * U, const
          gsl_vector * V)
     This function performs a rank-1 update w v^T of the QRP^T
     decomposition (Q, R,P). The update is given by Q'R' = Q R + w v^T
     where the output matrices Q' and R' are also orthogonal and right
     triangular. Note that W is destroyed by the update. The
     permutation P is not changed.

 - Function: int gsl_linalg_QRPT_Rsolve (const gsl_matrix * QR, const
          gsl_permutation * P, const gsl_vector * B, gsl_vector * X)
     This function solves the triangular system R P^T x = b for the
     N-by-N matrix R contained in QR.

 - Function: int gsl_linalg_QRPT_Rsvx (const gsl_matrix * QR, const
          gsl_permutation * P, gsl_vector * X)
     This function solves the triangular system R P^T x = b in-place
     for the N-by-N matrix R contained in QR. On input X should contain
     the right-hand side b, which is replaced by the solution on output.

Singular Value Decomposition
============================

   A general rectangular M-by-N matrix A has a singular value
decomposition (SVD) into the product of an M-by-N orthogonal matrix U,
an N-by-N diagonal matrix of singular values S and the transpose of an
M-by-M orthogonal square matrix Q,

     A = U S Q^T

The singular values \sigma_i = S_{ii} are all non-negative and are
generally chosen to form a non-increasing sequence \sigma_1 >= \sigma_2
>= ... >= \sigma_N >= 0.

   The singular value decomposition of a matrix has many practical uses.
The condition number of the matrix is given by the ratio of the largest
singular value to the smallest singular value. The presence of a zero
singular value indicates that the matrix is singular. The number of
non-zero singular values indicates the rank of the matrix.  In practice
singular value decomposition of a rank-deficient matrix will not produce
exact zeroes for singular values, due to finite numerical precision.
Small singular values should be edited by chosing a suitable tolerance.

 - Function: int gsl_linalg_SV_decomp (gsl_matrix * A, gsl_matrix * Q,
          gsl_vector * S)
     This function factorizes the M-by-N matrix A into the singular
     value decomposition A = U S Q^T. On output the matrix A is
     replaced by U. The diagonal elements of the singular value matrix
     S are stored in the vector S. The singular values are non-negative
     and form a non-increasing sequence from S_1 to S_N. The matrix Q
     contains the elements of Q in untransposed form. To form the
     product U S Q^T it is necessary to take the transpose of Q.

     The algorithm used in the decomposition is One-Sided Jacobi
     orthogonalization (see references for details).

 - Function: int gsl_linalg_SV_solve (gsl_matrix * U, gsl_matrix * Q,
          gsl_vector * S, const gsl_vector * B, gsl_vector * X)
     This function solves the system A x = b using the singular value
     decomposition of A given by `gsl_linalg_SV_decomp', (U, S, Q).

     Only non-zero singular values are used in computing the solution.
     The parts of the solution corresponding to singular values of zero
     are ignored.  Other singular values can be edited out by setting
     them to zero before calling this function.

     In the over-determined case where A has more rows than columns the
     system is solved in the least squares sense, returning the solution
     X which minimizes ||A x - b||_2.

Cholesky Decomposition
======================

   A symmetric, positive definite square matrix A has a Cholesky
decomposition into a product of a lower triagular matrix L and its
transpose L^T,

     A = L L^T

This is sometimes referred to as taking the square-root of a matrix. The
Cholesky decomposition can only be carried out when all the eigenvalues
of the matrix are positive.  This decomposition can be used to convert
the linear system A x = b into a pair of triangular systems (L y = b,
L^T x = y), which can be solved by forward and back-substitution.

 - Function: int gsl_linalg_cholesky_decomp (gsl_matrix * A)
     This function factorizes the positive-definite square matrix A
     into the Cholesky decomposition A = L L^T. On output the diagonal
     and lower triangular part of the input matrix A contain the matrix
     L. The upper triangular part of the input matrix contains L^T, the
     diagonal terms being identical for both L and L^T.  If the matrix
     is not positive-definite then the decomposition will fail,
     returning the error code `GSL_EDOM'.

 - Function: int gsl_linalg_cholesky_solve (const gsl_matrix *
          CHOLESKY, const gsl_vector * B, gsl_vector * X)
     This function solves the system A x = b using the Cholesky
     decomposition of A into the matrix CHOLESKY given by
     `gsl_linalg_cholesky_decomp'.

 - Function: int gsl_linalg_cholesky_svx (const gsl_matrix * CHOLESKY,
          gsl_vector * X)
     This function solves the system A x = b in-place using the
     Cholesky decomposition of A into the matrix CHOLESKY. On input X
     should contain the right-hand side b, which is replaced by the
     solution on output.